<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<title>Box Sizing Demo</title>

	<style>
		* {
		    margin: 0;
		    padding: 0;
		}

		/*Without border-box*/
		/*Border and padding is added to get the total width*/
		/*1px border + 50px left padding + 150px width + 50px right padding + 1px border = 252px*/

		#box {
		    height: 150px;
		    width: 150px;
		    margin: 50px;
		    padding: 50px;
		    border: 0px solid black;
		    background-color: orange;
		}

		/*With border-box*/
		/*Border and padding is included in the total width computation*/
		/*1px border + 50px left padding + 48px width + 50px right padding + 1px border = 150px*/

		#box2 {
			/* 
				- The "box-sizing" property defines how the width and height of an element are calculated.
				- This will allow us to control the measurements of elements better.
				- The value "border-box" includes the "padding" and "border" properties of an element to the total height and width in it's computation.
			 */
			box-sizing: border-box;
		    height: 150px;
		    width: 150px;
		    margin: 50px;
		    padding: 50px;
		    border: 0px solid black;
		    background-color: red;
		}

	</style>

	</head>
	<body>
		<!-- 
		The advantages of using border-box are:

			- Reflects the actual space being occupied and displayed on the screen.
			- Makes design calculations and logic easier.
			- It helps make the box model and hence the layout more consistent.
			- Layouts are more predictable and easier to visualize.

		 -->
		<div id="box">Without border-box</div>
		<div id="box2">With border-box</div>

	</body>
</html>